/*Ŀ
 ݳ Program Name: NPAD.PRG          Copyright: PUBLIC DOMAIN             
 ݳ Date Created: 12/19/92           Language: Clipper 5.0               
 ݳ Time Created: 09:38:53             Author: Kevin S Gallagher         
 ݳ                                                                      
 ݳ UDC NOTEPAD : Used to make FUNcky's notepad simple to setup          
 ݳ                                                                      
 ݳ Both of the above make setting up FUNcky II notepad editng system    
 ݳ very simple. By using the UDC, you can pass the parameters to the    
 ݳ notepad in any order that you wish.                                  
 ݳ                                                                      
 ݳ The basic stuff needed is:                                           
 ݳ 1) Filename of a file or some text                                   
 ݳ 2) A User Define Function for controlling keystrokes in notepad      
 ݳ Options:                                                             
 ݳ 1) box coordinates - type of frame, color of frame and text          
 ݳ 2) Defaults for buffer size, tab settings, EOL character etc.        
 ݳ 3) Save/Restore prior screen - prior to using the notepad.           
 ݳ                                                                      
 ݳ Feel free to modify!                                                 
 
            */

#include "npad.h"

function FUNPAD( nTop,nLeft,nBottom,nRight,nBoxcolor,nBoxtype,nBuf,nMaxLine,;
                 nWrapcol,nTabby,cText,lfile,cTitle,rscrn,bfunc,cFile       )
    local o, oldscrn, nHandle:=0, cBuf:=SPACE(F_BLOCK), RetVal:="OK"

    oldscrn   := if( rscrn, SaveVideo(nTop,nLeft-1,nBottom+1,nRight), NIL)
    nTop      := if(ValType(nTop)      = "N", nTop,1)
    nLeft     := if(ValType(nLeft)     = "N", nLeft,3)
    nBottom   := if(ValType(nBottom)   = "N", nBottom,22)
    nRight    := if(ValType(nRight)    = "N", nRight,76)
    nBoxcolor := if(ValType(nBoxColor) = "N", nBoxColor,PAD_COLOR)
    nBoxtype  := if(ValType(nBoxtype)  = "N", nBoxType,1)
    cTitle    := if(ValType(cTitle)    = "C", cTitle,NIL)
    nBuf      := if(ValType(nBuf)      = "N", nBuf,4000)
    nMaxLine  := if(ValType(nMaxLine)  = "N", nMaxLine,500)
    nWrapcol  := if(ValType(nWrapcol)  = "N", nWrapcol,-2)
    nTabby    := if(ValType(nTabby)    = "N", nTabby,4)
    cText     := if(ValType(cText)     = "C", cText,"")
    lfile     := if(ValType(lfile)     = "L", lfile,.F.)
    cFile     := if(ValType(cFile)     = "C", UPPER(RTRIM(cFile)),NIL)

    if lfile                                     // read requested file
        if file( cFile )
            nHandle:= FOPEN( cFile, 0 )
            if FERROR() <> 0
                return FERROR()
            else
                FREAD(nHandle, @cBuf, F_BLOCK)
                FCLOSE(nHandle)
            endif
        else
            return 2                             // file not found
        endif
    else                                         // read text
        cBuf := cText
    endif
    if(cTitle != NIL, setTitle(cTitle,1,nBoxcolor),NIL)
    box(nTop, nLeft, nBottom, nRight, BOXFRAMES[ nBoxType ], nBoxColor)

    o:= NOTEPADNEW(nTop+1,                                            ;
                   nLeft+1,                                           ;
                   nBottom-1,                                         ;
                   nRight-1,                                          ;
                   nBoxColor,                                         ;
                   nBuf,                                              ;
                   nMaxLine,                                          ;
                   nWrapcol,                                          ;
                   nTabby                                             ;
    )
    o:Store(1,cBuf )
    
    EVAL(bfunc,o)                                // Play with it!
    setTitle("",0)

    if(oldscrn <> NIL,RestVideo(nTop,nLeft-1,nBottom+1,nRight,oldscrn),NIL)
    //
    // the return value does not send back much at this point, it is up to
    // you as a programmer to decide what to send back to you for error
    // checking..
    //
return RetVal


