/*Ŀ
 ݳ                                                                      
 ݳ Program Name: NPAD.H              Purpose: header file for NPAD.PRG  
 ݳ Date Created: 12/18/92           Language: Clipper 5.0               
 ݳ Time Created: 19:22:11             Author: Kevin S Gallagher         
 ݳ                                                                      
 ݳ If so inclined - feel free to clean up uneeded code (Not I)          
 
            */

#include "funcky.ch"

#xcommand NOTEPAD  [ <var> ]                                                ;
          [ TEXT <ctext> ]                                                  ;
          [ <file:FILE> ]                                                   ;
          [ <rscrn:RSCRN> ]                                                 ;
          [ TOP <top> ]                                                     ;
          [ LEFT <left> ]                                                   ;
          [ BOTTOM <bottom> ]                                               ;
          [ RIGHT <right> ]                                                 ;
          [ BOXCOLOR <boxcolor> ]                                           ;
          [ BOXTYPE  <boxtype> ]                                            ;
          [ BOXTITLE <title>   ]                                            ;
          [ BUFFERSIZE <bufsize> ]                                          ;
          [ MAXLINES <maxlines> ]                                           ;
          [ WRAPCOLUMN <wrapcol> ]                                          ;
          [ SETTABS <tabby> ]                                               ;
          [ EDITME <bfunc> ]                                                ;
          [ FILENAME <filename> ]                                           ;
                                                  =>                        ;
          [<var> :=] FUNPAD( <top>, <left>, <bottom>, <right>, <boxcolor>,  ;
                             <boxtype>, <bufsize>, <maxlines>, <wrapcol>,   ;
                             <tabby>, <ctext>, <.file.>, <title>,<.rscrn.>, ;
                             <{bfunc}>, <filename>                          )

#xtranslate LSTRINT( <f> )                        => LTRIM(STR(INT( <f> ) ) )

#define BOXFRAMES {"ͻȺ ","Ŀ ","͸Գ ","ķӺ ",SPACE(9) }

#command DEFAULT <p> TO <val> [,<pn> TO <valn>]   =>                        ;
                 <p> = iif(<p>  = NIL, <val>,  <p>)                         ;
                 [;<pn>  = iff(<pn> = NIL, <valn>, <pn>)]

//  System display colors etc.
#define BackColor    "W+/W"
#define STATUS_COLOR 95
#define FRAME_TITLE  15
#define MAGENTA      85
#define PAD_COLOR    23
#define PAD_BLOCK    127
#define FRAME_COLOR  PAD_COLOR

#define BackDrop()  dispbox(0,0,maxrow(),maxcol(),replicate("",9),BackColor)
#define NoteFrame() box(4,4,21,76,"͸Գ " ,FRAME_COLOR)

#define NO_SHOW_CR  32                           // hide Hard Return
#define UpWord      PADR(" "+UPPER(cWord),20)
#define FBLOCK      4000                         // Buffer to hold file
#define F_BLOCK     5000                         // Buffer to hold file
#define HOME_COL    1                            // Goto for HOME key
#define LAST_COL    100                          // GoTo for END key
#define END         6                            // END key (K_END)
#define nHardRet    13                           // For OverStrike Mode
#define MR          MAXROW()

#define NO_DEBUG()  ALTD( 0 )                    // Redefine CLD key

//  Keys and methods for notepad operations
#define MARK_BLOCK  304                          // ALT-B
#define CUT_BLOCK   302                          // ALT-C
#define DEL_LINE    288                          // ALT-D
#define PASTE_BLOCK 279                          // ALT-I
#define CENTER_LINE -15                          // SHIFT-F6

//  For development of UDC and testing of NotePad
#define IN_FILE     "TEST.TXT"            // File to work with



//    bfunc     := if(ValType(bfunc)     = "B", bfunc,NIL)

